/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

void kmpNotify::init()
{
    this->hide();
    showT = new QTimer(this);
    connect( showT, SIGNAL(timeout()), this, SLOT(doShow()) );
    hideT = new QTimer(this);
    connect( hideT, SIGNAL(timeout()), this, SLOT(doHide()) );
    waitT = new QTimer(this);
    connect( waitT, SIGNAL(timeout()), this, SLOT(hideIt()) );
    sizeW = titleL->minimumSize().width() + 28;
}



void kmpNotify::showIt( int corner, int wait)
{
    waitTime = wait;
    QDesktopWidget desktop;
    dt = desktop.screenGeometry();    
     if(QFontMetrics(l_song->font()).width( l_song->text() ) > sizeW)
            sizeW = 28+ QFontMetrics(l_song->font()).width( l_song->text() );
    if(QFontMetrics(l_artist->font()).width( l_artist->text() ) > sizeW)
            sizeW = 28+ QFontMetrics(l_artist->font()).width( l_artist->text() );
    if(QFontMetrics(l_album->font()).width( l_album->text() ) > sizeW)
            sizeW = 28+ QFontMetrics(l_album->font()).width( l_album->text() );
    if(QFontMetrics(l_kmp->font()).height() > 32) sizeH = QFontMetrics(l_kmp->font()).height();
    else sizeH = 42;
    sizeH += QFontMetrics(l_album->font()).height() +
                QFontMetrics(l_song->font()).height() +
                QFontMetrics(l_artist->font()).height() + 20;
    setFixedSize(sizeW, 0);
    initialx = -1;
    initialy = -1;
    if(corner == 0)
    {
        move(0, dt.height());

        fadeUp = true;
    } else if (corner == 1)
    {
        move(dt.width() - sizeW, dt.height());
        fadeUp = true;
    } else if (corner == 2)
    {
        move(dt.width() - width(), 0);
        fadeUp = false;
    } else if (corner == 3)
    {
        move(0,0);
        fadeUp = false;
    }
    
     this->clearWFlags(Qt::WType_Dialog | Qt::WStyle_NormalBorder | Qt::WStyle_DialogBorder | Qt::WStyle_Title | Qt::WStyle_SysMenu);
     this->setWFlags(Qt::WStyle_Customize | Qt::WStyle_NoBorder | Qt::WStyle_StaysOnTop | Qt::WX11BypassWM);
     this->update();
     this->repaint();
     this->show();

    showT->start(2);
}





void kmpNotify::hideIt()
{
    hideT->start(1);
}
void kmpNotify::doHide()
{
    if(height() < 2) {
        hideT->stop();
        this->hide();
        return;
    }
        setFixedSize( sizeW, height() - 2);
    if(fadeUp) move(x(), y() + 2);
    
    
}


void kmpNotify::doShow()
{
    if(initialx == -1) initialx = x();
    if(initialy == -1) initialy = y();
    if(fadeUp) move(x(), y() - 1);
    setFixedSize( sizeW, height() + 1);
    repaint();
    if(height() > sizeH) {
        showT->stop();
        waitT->start(waitTime);
    }
}




void kmpNotify::setNotify( QString name, QString artist, QString album )
{
    if(waitT->isActive()) {
        waitT->stop();
        waitT->start(waitTime);
    }
    sizeW = 45 + titleL->minimumSize().width();
    l_song->setText(name);
    l_song->setFixedSize(1200, QFontMetrics(l_song->font()).height());
    l_artist->setText(artist);
    l_artist->setFixedSize(1200, QFontMetrics(l_artist->font()).height());
    l_album->setText(album);
    l_album->setFixedSize(1200, QFontMetrics(l_album->font()).height());
}
